using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Reflection;

namespace evc
{
	internal class EnumList<EnumType>
		where EnumType : struct
	{
		private static EnumType[]	aEnumList = null;

		// vfXg擾		
		public static EnumType[] GetValues()
		{
			if ( EnumList<EnumType>.aEnumList == null )
			{
				List<EnumType>	lisType = new List<EnumType>();
				
				Array.ForEach( typeof(EnumType).GetFields( BindingFlags.Public |BindingFlags.Static ), delegate( FieldInfo inInfo )
				{
					lisType.Add( (EnumType)inInfo.GetValue(null) );
				});
				
				EnumList<EnumType>.aEnumList = lisType.ToArray();
			}
			
			return EnumList<EnumType>.aEnumList;
		}

	}
}
