using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using glb;

namespace evc
{
	// oCip
	public interface IseStateInput
	{
		bool ReadBool();
		byte ReadByte();
		short ReadShort();
		int ReadInt();
		float ReadFloat();
		string ReadString();
		T ReadEnum<T>() where T : struct;		// Enumǂݍ
	}

	// ǂݍ݃T|[g
	public partial class seIOUtil
	{
		// Enum̒ňԒl̑傫Ȃ̂擾(̂)
		internal static int EnumMaxValue<T>()  where T : struct
		{
			int iMaxValue = 0;
			T[] aeEnumList = EnumList<T>.GetValues();

			foreach (T tValue in aeEnumList )
			{
				int iValue = (int)Enum.Parse( tValue.GetType(), tValue.ToString(), false );
				iMaxValue = Math.Max( iMaxValue, iValue );
			}
			return iMaxValue;
		}


		// glbVector2ǂݍ
		public static glbVector2 ReadVector2( IseStateInput inInput )
		{
			float fX = inInput.ReadFloat();
			float fY = inInput.ReadFloat();
			return new glbVector2( fX, fY );
		}


		// glbColorǂݍ
		public static glbColor ReadColor( IseStateInput inInput )
		{
			byte R = inInput.ReadByte();
			byte G = inInput.ReadByte();
			byte B = inInput.ReadByte();
			byte A = inInput.ReadByte();
			return new glbColor( R,G,B,A );
		}
	}
}
