﻿using System;
using System.Collections.Generic;
using System.Text;

namespace evc
{
	// 操作するキーリスト:ロード時に自動生成。セーブしない。
	// 
	
	public partial class seKeyControlManager : seIDManager<seStateKeyInfo>
	{
		// 追加時
		public override int Add(seStateKeyInfo tData)
		{
			// 無効な名前が登録されたなら
			if (string.IsNullOrEmpty(tData.Name))
			{
				// リストから削除
				base.Remove( tData );
				return seKeyControlManager.InvalidID;
			}

			return base.Add( tData );
		}

		// 名前から情報取得
		public seStateKeyInfo Find( string name )
		{
			if (string.IsNullOrEmpty(name)) return null;

			seStateKeyInfo retKey = null;
			this.DoAll( delegate( int iID, seStateKeyInfo inKeyInfo )
			{
				if ( name == inKeyInfo.Name )
				{
					retKey = inKeyInfo;
					return false;
				}
				return true;
			});
			return retKey;
		}
	}

}
