﻿
namespace glb
{
	public partial interface IGLMatrix
	{
		void SetScale( glbVector2 sScale );
		void SetScale( float fX, float fY );

		void SetPos( glbVector2 sPos );
		void SetPos( float fX, float fY );

		void SetRotZ( float fZ );

		// テクスチャマトリクス用UVセット
		void SetUV( glbVector2 sUV );
		void SetUV( float fU, float fV );

		void Mul( IGLMatrix inMatrix );		// *=
		void MulR( IGLMatrix inMatrix );	// *= : 逆から掛ける


		// ２頂点と掛け算
		glbVector2 TransformCoordinate( glbVector2 sMstPos );

		// 値をコピー
		void Copy( IGLMatrix inMatrix );

		// 逆マトリクスに変換する
		void Invert ();
		// 単位マトリクスにする
		void Identity ();
	}
}
