using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using evc;


namespace evcIO
{
	internal class trFile : siFile
	{
		private FileStream	inStream = null;
		private byte[]		abBuffer = null;
		private bool		bFinish = false;


		internal trFile ( string strPath )
		{
//			seSceneManager inSm = seRootScene.ActiveScene;
	
			this.inStream = File.Open( strPath, FileMode.Open, FileAccess.Read );
			this.abBuffer = new byte[ inStream.Length ];
			this.inStream.BeginRead( this.abBuffer, 0, this.abBuffer.Length, this.AsyncCallback, null );
		}

		// [hR[obN
		private void AsyncCallback ( IAsyncResult ar )
		{
			// Xg[
			if ( this.inStream != null )
			{
				this.inStream.Close();
			}
			this.bFinish = true;
		}

		// t@C[hIۂ
		public bool IsLoadFinish		{ get { return this.bFinish; } }

		// [ht@Cf[^擾
		public byte[] Buffer
		{
			get 
			{
				if ( !this.bFinish ) return null;
				return this.abBuffer;
			}
		}

		// ԍXV
		public void Update(){}


		// [ḧ̉
		public void Dispose()
		{
			if ( this.inStream != null ) 
			{
				this.inStream.Close();
			}
			this.bFinish = false;
		}
	}
}
