using System;
using System.Collections.Generic;
using System.Windows.Media.Imaging;
using evc;
using glb;

namespace evcIO
{

	// pC[WǗ
	internal class trObjectFontImageManager : IDisposable
	{
		private trObjectFont		_parent = null;

		// f[^Xg
		private Dictionary<int,Dictionary<char,trObjectFontChar>> dicCharInfo = new Dictionary<int,Dictionary<char,trObjectFontChar>>();
		// X^CǗNX
		private trObjectFontStyleManager	inStyleManager = new trObjectFontStyleManager();


		// ǗNX쐬
		public siObjectFontChar CreateChar( int iFontStyle, char cChar )
		{
			// ɓo^ĂȂ炻̏Ԃ
			Dictionary<char,trObjectFontChar> dicChar;
			if ( !this.dicCharInfo.TryGetValue( iFontStyle, out dicChar ) )
			{
				dicChar = new Dictionary<char,trObjectFontChar>();
				this.dicCharInfo[ iFontStyle ] = dicChar;
			}

			trObjectFontChar font;
			if ( !dicChar.TryGetValue( cChar, out font ) )
			{
				font = (trObjectFontChar)this._parent.CreateChar( iFontStyle, cChar );
				dicChar[ cChar ] = font;
			}

			return font;
		}

		// tHgX^CNX擾
		internal trObjectFontStyle FindStyle(int iStyleID)
		{
			return this.inStyleManager.Find(iStyleID);
		}

		// tHgX^C쐬
		public int CreateFontStyle( string strFontName, float fHeight, seFontStyle Style )
		{
			return this.inStyleManager.Create( strFontName, fHeight, Style );
		}


		// RXgN^
		public trObjectFontImageManager ( trObjectFont parent )
		{
			this._parent = parent;
		}

		// ̈̉
		public void Dispose()
		{
			this.Clear();
		}

		// f[^SăNA
		internal void Clear()
		{
			// tHgX^CNA
			this.inStyleManager.Clear();

			// f[^NA
			this.dicCharInfo.Clear();
		}
	}
}
