using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using evc;
using glb;
using sl;

namespace evcIO
{
	// TEhǗ
	public class trObjectSound : siObjectSound , IDisposable
	{
		private MediaElement inSound = new MediaElement();
		private bool bLoop = false;
		private TimeSpan sStartPos;


		public trObjectSound ( siResourceSound inResource )
		{
			this.inSound.AutoPlay = false;
			this.inSound.SetSource( ((trResourceSound)inResource).Sound );
			this.inSound.Stop();

			slPutManager.Instance.Children.Add( this.inSound );
		}

		// pXVꂽ
		public void UpdatePan( int iPan )
		{
			// ϊĐݒ
			this.inSound.Balance = (double)iPan * (1.0 / 1000.0);
		}
		// {[XVꂽ
		public void UpdateVolume( int iVolume )
		{
			// Pʕϊ 0`10000.0`1.0FAA
			// ftHgl0.5Ȃ̂Ō݂0.0`0.5ƂB
			this.inSound.Volume = (double)iVolume * (1.0 / 2000.0);
		}

		// Đv
		public void Play( int iElemID, float fStartTime, bool bInLoop )
		{
			this.bLoop = bInLoop;
			// [vݒ
			if ( this.bLoop )
			{
				this.inSound.CurrentStateChanged += new RoutedEventHandler(inSound_CurrentStateChanged);
			}

			this.sStartPos = new TimeSpan( (long)fStartTime );
			this.inSound.Position = this.sStartPos;
			this.inSound.AutoPlay = true;
			this.inSound.Play();
		}

		public void Play( int iElemID, float fStartTime, float fLength, bool bLoop )
		{
			// Đ(fLength)͍̂Ƃ떢Ή
			// 
	
			this.Play( iElemID, fStartTime, bLoop );
		}
		
		// ~v
		public void Stop()
		{
			this.inSound.Stop();
			// [vCxg폜
			if ( this.bLoop )
			{
				this.inSound.CurrentStateChanged -= new RoutedEventHandler(inSound_CurrentStateChanged);
				this.bLoop = false;
			}
		}

		// Xe[^XύXiɃ[vp)
		void inSound_CurrentStateChanged(object sender, System.Windows.RoutedEventArgs e)
		{
			if ( (this.inSound.CurrentState == MediaElementState.Paused) && this.bLoop )
			{
				this.inSound.Position = this.sStartPos;
				this.inSound.Play();
			}
		}


		// fobOp`(\Ȃ)
		public void Draw( IGLMatrix m, int iVolume, int iPan )
		{
		}
		
		// 
		public void Dispose()
		{
			this.inSound = null;
		}
	}
}
