﻿using System;
using System.Collections.Generic;
using System.Text;
using glb;


namespace evc
{
	// 線形補間(再生用)
	public partial class FpAnimLiner : IFeAnimBase
	{
		// フレーム(0.0f～1.0f)に対する進行度を取得
		public float GetFramePos( float fAnimFrame, FePointInfo befoInfo, FePointInfo nowInfo )
		{
			float fBfoRate = befoInfo.Rate;
			float fRate = (fAnimFrame - fBfoRate) / (nowInfo.Rate - fBfoRate);

			float fBfoValue = befoInfo.Value;
			return (nowInfo.Value - fBfoValue) * fRate + fBfoValue;
		}

		public void Load(IseStateInput inInput){}
	}
}
