﻿using System;
using System.Collections.Generic;
using System.Text;
using glb;


namespace evc
{
	// ボタン種類
	[ Flags ]
	public enum ButtonType
	{
		Button1		= 1,
		Button2		= 1 << 1,
		Button3		= 1 << 2,
		Button4		= 1 << 3,
		Button5		= 1 << 4,
		Button6		= 1 << 5,
		Button7		= 1 << 6,
		Button8		= 1 << 7,
		Button9		= 1 << 8,
		Button10	= 1 << 9,
		Button11	= 1 << 10,
		Button12	= 1 << 11,
		Button13	= 1 << 12,
		Button14	= 1 << 13,
		Button15	= 1 << 14,
		Button16	= 1 << 15,
		Button17	= 1 << 16,
		Button18	= 1 << 17,
		Button19	= 1 << 18,
		Button20	= 1 << 19,
		Button21	= 1 << 20,
		Button22	= 1 << 21,
		Button23	= 1 << 22,
		Button24	= 1 << 23,
		Button25	= 1 << 24,
		Button26	= 1 << 25,
		Button27	= 1 << 26,
		Button28	= 1 << 27,
		Button29	= 1 << 28,
		Button30	= 1 << 29,
		Button31	= 1 << 30,
		Button32	= 1 << 31,
	}


	// イベント用入出力管理インタフェース
	public interface siEventIO
	{
		// 入力状態の更新
		void Update();

		// 現在押されているボタンを取得
		ButtonType PushButton { get; }
		// ポインタの位置を取得
		glbVector2 Pointer { get; }
		// ポインタが動いたか否かを取得
		bool IsMovePointer { get; }
	}
}
