using System;
using System.Diagnostics;
using glb;

namespace evc
{
	// pɂɎgꎞIMatrix͖new؂Ďgp܂B
	// 


	// }gNX[N擾
	public interface IUseWorkMatrix
	{
		IGLMatrix GetMatrix();
	}

	// }gNX[N
	internal class seMatrixWork : IUseWorkMatrix
	{
		// VOg
		private static seMatrixWork	inInstance = new seMatrixWork();
		public static seMatrixWork Instance {get { return seMatrixWork.inInstance; }}

		private const int MaxMatrix = 16;	// }gNX
		private IGLMatrix[] _workMatrix = null;
		private int	iStackNum = 0;	// gp}gNX

		public IGLMatrix Identity { get; private set; }	// Pʃ}gNX

		// RXgN^
		private seMatrixWork ()
		{
			siIOManager io = seRootScene.Instance.IOManager;

			this._workMatrix = new IGLMatrix[ seMatrixWork.MaxMatrix ];
			for (int i = 0; i < this._workMatrix.Length; i++)
			{
				this._workMatrix[ i ] = io.CreateMatrix();
			}

			// Pʃ}gNX
			this.Identity = io.CreateMatrix();
			this.Identity.Identity();
		}


		// Cӂ͈͓̔Ń}gNX[N̎gpJn邱Ƃ錾
		public int StartMatrix()
		{
			return this.iStackNum;
		}

		// Cӂ͈͓̔Ń}gNX[N̎gpI
		public int EndMatrix( int iStackHandle )
		{
			return this.iStackNum = iStackHandle;
		}

		// L}gNX擾:(\bhŊMatrixɑ΂Ďgp)
		// ̃O[oϐȂ̂ő̃\bhŎgpĂ邩ӂKvB
		// {IɍœK̕KvƂɂ̂ݎgB
		public IGLMatrix GetMatrix()
		{
			this.iStackNum ++;
			Debug.Assert( this.iStackNum < seMatrixWork.MaxMatrix );
			return this._workMatrix[ this.iStackNum - 1 ];
		}
		


		// }gNX[NĝɍsOAIbv
		public void UseMatrixWork( Action<IUseWorkMatrix> inFunc )
		{
			int iStartID = this.StartMatrix();
			inFunc( this );
			this.EndMatrix( iStartID );
		}


	}
}
