﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Diagnostics;
using glb;

namespace evc
{
	/**
	 * １要素の複数アニメーション管理クラス
	 */
	public partial class seElemAnimManager : seIDManager<seElemAnim>
	{
		private Dictionary<int,int> dd = new Dictionary<int,int>();

		// 入力
		public void Load( IseStateInput input, seSceneManager scene )
		{
			this.Clear();

			int iCount = (int)input.ReadShort();
			seDefine.DebugTrace( "AnimCount", iCount );
			for (int i = 0; i < iCount; i++)
			{
				int iAnimID = (int)input.ReadShort();
				seDefine.DebugTrace( "AnimID", iAnimID );

				seElemAnim elemAnim = new seElemAnim();
				elemAnim.Load( input, scene );
				this.Add(iAnimID, elemAnim);
			}
		}

	}
}
