﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using glb;

namespace evc
{
	/**
	 * 描画オブジェクトを描画するのに要素毎に必要なデータ管理インタフェース
	 */
	public abstract partial class seObjectWork
	{
		// 描画オブジェクトを取得
		public abstract seObject Object { get; }

		// オブジェクトのサイズを取得
		public abstract glbVector2 GetSize();

		// 内部ワークをリセットする
		internal virtual void Reset(){}
		// 描画	
		internal abstract void Draw ();
		// 更新
		internal abstract void Update ( float fAddTime );
	}
	
}
