using System;
using System.Collections.Generic;
using System.Text;
using glb;
using evc;
using System.IO;

namespace evcIO
{
	// eNX`C[WǗ
	
	public class trResourceSound : siResourceSound
	{
		private const int MIN_STREAM_SIZE = 	1024 * 200;		// ŒXg[TCY:Ƃ肠200K


		// WavtH[}bg擾
		private WavFormatCtrl inWavFormat = null;
		internal WavFormatCtrl WavFormat { get { return this.inWavFormat; } }

		// t@CXg[̎擾Eݒ
		private Stream inStream = null;
		internal Stream Stream { get { return inStream; }}


		public trResourceSound ( string strInSoundName )
			:base( strInSoundName )
		{

		}


		// V[
		public override siResourceInitType Init( byte[] abData /* = null */ )
		{
			FileInfo inFileInfo = new FileInfo( base.Name );
			// t@CTCYȉȂ烁ɓǂݍł܂B
			if ( inFileInfo.Length < trResourceSound.MIN_STREAM_SIZE )
			{
				this.inStream = new MemoryStream( File.ReadAllBytes( base.Name ) );
			}
			else
			{
				this.inStream = File.Open( base.Name, FileMode.Open, FileAccess.Read );
			}

			this.inWavFormat = new WavFormatCtrl();
			this.inWavFormat.Register( this.inStream );

			return siResourceInitType.Success;
		}

	
		// \[X
		public override void Dispose()
		{
			// Xg[̏I
			if ( this.inStream != null )
			{
				this.inStream.Close();
				this.inStream.Dispose();
				this.inStream = null;
			}
		}
	}
}
