using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using evc;
using glb;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace evcIO
{
	// }eAǗ
	internal class trMaterial : siMaterial
	{
		// }XNl̎擾Eݒ
		// }XN(255-̒l)ȏ̃At@sNZLɂȂ܂B
		public int MaskAlpha { get; set; }		
		// d˃^Cv擾Eݒ
		public DoublyType DoublyType { get; set; }
		// uh^Cv̎擾Eݒ
		public BlendType BlendType { get; set; }


		public trMaterial ()
		{
			this.MaskAlpha = 255;
		}


		// Ԃ𔽉f
		public void Apply()
		{
			RenderStateManager rs = trIOManager.Device.RenderState;
			// d˃^Cv
			switch (this.DoublyType)
			{
				// }XNC[W`p
				case DoublyType.Mask:
					// At@eXg
					// ȏ̃At@lsNZiɂ
					rs.AlphaTestEnable = true;
					rs.AlphaFunction = Compare.Greater;
					rs.ReferenceAlpha = 255 - this.MaskAlpha;

					// At@uh
					// `悵Ȃ
					rs.AlphaBlendEnable= true;
					rs.BlendOperation = BlendOperation.Add;
					rs.SourceBlend = Blend.Zero;
					rs.DestinationBlend = Blend.One;
					
					// fvXeXg
					// ōi
					rs.ZBufferEnable = true;
					rs.ZBufferWriteEnable = true;
					rs.ZBufferFunction = Compare.Always;
					break;

				// }XNKC[Wp
				case DoublyType.MaskReflection:
					// At@eXg֌W
					rs.AlphaTestEnable = false;
					
					// fvXeXg֌W
					rs.ZBufferEnable = true;
					rs.ZBufferWriteEnable = false;
					rs.ZBufferFunction = Compare.GreaterEqual;

					// uh^Cv𔽉f
					this.ApplyBlendType();
					break;

				// ʏ
				case DoublyType.Normal:
					rs.ZBufferEnable = false;
					rs.AlphaTestEnable = false;
					// uh^Cv𔽉f
					this.ApplyBlendType();
					break;

				default:
					// uh^Cv𔽉f
					this.ApplyBlendType();
					break;
			}
		}

		// uh^Cv𔽉f
		private void ApplyBlendType()
		{
			RenderStateManager rs = trIOManager.Device.RenderState;

			switch ( this.BlendType )
			{
				case BlendType.ADD:
					rs.AlphaBlendEnable = true;
					rs.BlendOperation	= BlendOperation.Add;
					rs.SourceBlend		= Blend.SourceAlpha;
					rs.DestinationBlend = Blend.One;
					break;

				case BlendType.NON:
					rs.AlphaBlendEnable = false;
					break;

				case BlendType.NORMAL:
					rs.AlphaBlendEnable = true;
					rs.BlendOperation	= BlendOperation.Add;
					rs.SourceBlend		= Blend.SourceAlpha;
					rs.DestinationBlend = Blend.InvSourceAlpha;
					break;

				case BlendType.XOR:
					rs.AlphaBlendEnable = true;
					rs.BlendOperation	= BlendOperation.Add;
					rs.SourceBlend		= Blend.InvDestinationColor;
					rs.DestinationBlend = Blend.Zero;
					break;
				default:
					break;
			}
		}

	}
}
