using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using glb;

namespace evcIO
{
	internal class trMatrix : IGLMatrix
	{
		// }gNX
		private Matrix m;
		internal Matrix Matrix	{ get { return this.m; } set { this.m = value; }}

		// RXgN^
		public trMatrix ()
		{
		}

		// XP[ݒ
		public void SetScale( float fX, float fY )
		{
			this.m.Scale( fX, fY, 1.0f );
		}
		public void SetScale( glbVector2 sScale )
		{
			this.m.Scale( sScale.X, sScale.Y, 1.0f );
		}


		// ړlݒ
		public void SetPos( float fX, float fY )
		{
			this.m.Translate( fX, fY, 0.0f );
		}
		public void SetPos( glbVector2 sPos )
		{
			this.m.Translate( sPos.X, sPos.Y, 0.0f );
		}


		// y]ݒ
		public void SetRotZ( float fZ )
		{
			this.m.RotateZ( fZ );
		}
		
		// eNX`}gNXpUVZbg
		public void SetUV( float fU, float fV )
		{
			this.Identity();
			this.m.M31 = fU;
			this.m.M32 = fV;
		}
		public void SetUV( glbVector2 sUV )
		{
			this.Identity();
			this.m.M31 = sUV.X;
			this.m.M32 = sUV.Y;
		}

		// t}gNXɕϊ
		public void Invert ()
		{
			this.m = Matrix.Invert( this.m );
		}
		// Pʃ}gNXɂ
		public void Identity ()
		{
			this.m = Matrix.Identity;
		}

		// lRs[
		public void Copy( IGLMatrix inMatrix )
		{
			trMatrix m = (trMatrix)inMatrix;
			this.m = m.Matrix;
		}

		public void Mul( IGLMatrix inMatrix )
		{
			trMatrix m = (trMatrix)inMatrix;
			this.m = m.Matrix * this.m;
		}

		public void MulR( IGLMatrix inMatrix )
		{
			trMatrix m = (trMatrix)inMatrix;
			this.m = this.m * m.Matrix;
		}

		// glbVector2 * Matrix
		public glbVector2 TransformCoordinate ( glbVector2 sMstPos )
		{
			Vector2 v = Vector2.TransformCoordinate( new Vector2( sMstPos.X, sMstPos.Y ), this.m );
			return new glbVector2( v.X, v.Y );
		}
	}
}
