using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Controls;
using evc;
using glb;
using sl;

namespace evcIO
{
	// eNX`C[WǗ
	
	public class trResourceTexture : siResourceTexture
	{
		private WriteableBitmap _imagePix;

		// eNX`
		public Stream Texture { get; private set; }

		// eNX`TCY擾
		private glbVector2I sTextureSize;
		public override glbVector2I TextureSize	{ get { return this.sTextureSize; } }

		// RXgN^
		public trResourceTexture( string strInTextureName, glbVector2I sInTextureSize )
			: base( strInTextureName )
		{
			this.sTextureSize = sInTextureSize;
		}

		// eNX`
		public override siResourceInitType Init( byte[] abData )
		{
			this.Texture = new MemoryStream( abData );

			// C[WƂĎgpł邩eXg
			try
			{
				BitmapImage bmp = new BitmapImage();
				bmp.SetSource(this.Texture);
				this._imagePix = new WriteableBitmap( bmp );
			}
			catch (Exception)
			{
				MessageBox.Show( this.Name + "̓o^Ɏs܂BT|[gĂȂ摜tH[}bg̉\܂B" );
				this.Texture.Dispose();
				this.Texture = null;
				return siResourceInitType.Failure;
			}
			return siResourceInitType.Success;
		}

		// \[X
		public override void Dispose()
		{
			if ( this.Texture != null )
			{
				this.Texture.Close();
				this.Texture.Dispose();
				this.Texture = null;
			}
		}

		// 蔻
		public override bool IsHit(glbVector2I sPos)
		{
			if ( this._imagePix == null) return false;
			int index = this._imagePix.PixelWidth * sPos.Y + sPos.X;
			if ( (index < 0) || (index >= this._imagePix.Pixels.Length) ) return false;
			int iPix = this._imagePix.Pixels[ index ];

			return ((iPix & 0xff000000) != 0);
		}
	}
}
